<cfcomponent displayname="ProductService">

<cffunction name="init" access="Public" returntype="any">
	<!--- Old --->
	<cfargument name="Transfer" type="any" required="true" />
	<cfset variables.Transfer = arguments.Transfer />
	<!--- New --->
	<cfargument name="ProductGateway" type="any" required="yes" />
	<cfset variables.ProductGateway = arguments.ProductGateway />

	<cfreturn this />
</cffunction>


<cffunction name="getProduct" access="Public" returntype="any">
	<cfargument name="ProductId" type="any" required="yes" />
	<!--- Old --->
	<cfif Val(arguments.ProductId) EQ 0>
		<cfset objProduct = variables.Transfer.new("product.Product") />
	<cfelse>
		<cfset objProduct = 
			variables.Transfer.get("product.Product",arguments.ProductId) />
	</cfif>
	<cfreturn objProduct />
	<!--- New --->
	<cfreturn variables.ProductGateway.getProduct(arguments.ProductId) />
</cffunction>


<cffunction name="updateProduct" access="public" output="false" returntype="any" hint="I add or update a Product.">
	<cfargument name="ProductId" type="any" required="yes" />
	<cfargument name="data" type="any" required="yes" />
	
	<cfset var Errors = ArrayNew(1) />
	
	<!--- Get a Product object to work with --->
	<cfset objProduct = getProduct(arguments.ProductId) />

	<!--- Populate the Product with data provided by the user --->
	<cfloop collection="#arguments.data#" item="datum">
		<cfif StructKeyExists(objProduct, "set#datum#")>
			<cftry>
				<cfinvoke component="#objProduct#" method="set#datum#">
					<cfinvokeargument 
						name="#datum#" 
						value="#arguments.data[datum]#" />
				</cfinvoke>
				<cfcatch type="any">
					<cfset ArrayAppend(Errors,
						"There was a problem setting the #datum#!") />
				</cfcatch>
			</cftry>
		</cfif>
	</cfloop>
	
	<!--- Product Name is required --->
	<cfif Len(arguments.data.ProductName) EQ 0>
		<cfset ArrayAppend(Errors,"The Product Name must not be blank!") />
	</cfif>

	<cfif ArrayLen(Errors) EQ 0>
		<!--- OK to save the Product --->
		<!--- Old --->
		<cfset variables.Transfer.save(objProduct) />
		<!--- New --->
		<cfset variables.ProductGateway.saveProduct(objProduct) />
	</cfif>
	
	<cfreturn Errors />
</cffunction>

</cfcomponent>
