<cfcomponent displayname="ProductService">

<cffunction name="init" access="Public" returntype="any">
	<cfargument name="ProductGateway" type="any" required="yes" />
	<cfset variables.ProductGateway = arguments.ProductGateway />
	<cfreturn this />
</cffunction>


<cffunction name="getProduct" access="Public" returntype="any">
	<cfargument name="ProductId" type="any" required="yes" />
	<cfreturn variables.ProductGateway.getProduct(arguments.ProductId) />
</cffunction>


<cffunction name="updateProduct" access="public" returntype="any">
	<cfargument name="ProductId" type="any" required="yes" />
	<cfargument name="data" type="any" required="yes" />
	
	<cfset var Errors = ArrayNew(1) />
	
	<!--- Get a Product object to work with --->
	<cfset objProduct = getProduct(arguments.ProductId) />

	<!--- Populate the Product with data provided by the user --->
	<!--- Old --->
	<cfloop collection="#arguments.data#" item="datum">
		<cfif StructKeyExists(objProduct, "set#datum#")>
			<cftry>
				<cfinvoke component="#objProduct#" method="set#datum#">
					<cfinvokeargument 
						name="#datum#" 
						value="#arguments.data[datum]#" />
				</cfinvoke>
				<cfcatch type="any">
					<cfset ArrayAppend(Errors,
						"There was a problem setting the #datum#!") />
				</cfcatch>
			</cftry>
		</cfif>
	</cfloop>
	<!--- New --->
	<cfset Errors = objProduct.populate(arguments.data,Errors) />

	<!--- Old --->	
	<!--- Product Name is required --->
	<cfif Len(arguments.data.ProductName) EQ 0>
		<cfset ArrayAppend(Errors,"The Product Name must not be blank!") />
	</cfif>
	<!--- New --->
	<!--- Make sure the Product is still valid --->
	<cfset Errors = objProduct.validate(Errors) />

	<cfif ArrayLen(Errors) EQ 0>
		<!--- OK to save the Product --->
		<cfset variables.ProductGateway.saveProduct(objProduct) />
	</cfif>
	
	<cfreturn Errors />
</cffunction>

</cfcomponent>
