<cfcomponent displayname="ProductService">

<cffunction name="init" access="Public" returntype="any">
	<cfargument name="ProductGateway" type="any" required="yes" />
	<cfset variables.ProductGateway = arguments.ProductGateway />
	<cfreturn this />
</cffunction>


<cffunction name="getProduct" access="Public" returntype="any">
	<cfargument name="ProductId" type="any" required="yes" />
	<cfreturn variables.ProductGateway.getProduct(arguments.ProductId) />
</cffunction>


<cffunction name="updateProduct" access="public" returntype="any">
	<cfargument name="ProductId" type="any" required="yes" />
	<cfargument name="data" type="any" required="yes" />
	
	<!--- Old --->
	<cfset var Errors = ArrayNew(1) />
	<!--- New --->
	<cfset var objResult = 
		CreateObject("component","model.util.Result").init() />

	<!--- Get a Product object to work with --->
	<cfset objProduct = getProduct(arguments.ProductId) />

	<!--- Populate the Product with data provided by the user --->
	<!--- Old --->
	<cfset Errors = objProduct.populate(arguments.data,Errors) />
	<!--- New --->
	<cfset objProduct.populate(arguments.data,objResult) />

	<!--- Make sure the Product is still valid --->
	<!--- Old --->	
	<cfset Errors = objProduct.validate(Errors) />
	<!--- New --->
	<cfset objProduct.validate(objResult) />

	<!--- Old --->	
	<cfif ArrayLen(Errors) EQ 0>
	<!--- New --->
	<cfif objResult.getIsSuccess()>
		<!--- OK to save the Product --->
		<cfset variables.ProductGateway.saveProduct(objProduct) />
	</cfif>
	
	<!--- Old --->	
	<cfreturn Errors />
	<!--- New --->	
	<cfreturn objResult />
</cffunction>

</cfcomponent>
