<cfcomponent displayname="Product">

<cffunction name="populate" access="public" returntype="void">
	<cfargument name="data" type="any" required="yes" />
	<!--- Old --->
	<cfargument name="Errors" type="any" required="yes" />
	<!--- New --->
	<cfargument name="objResult" type="any" required="yes" />
	
	<cfloop collection="#arguments.data#" item="datum">
		<cfif StructKeyExists(this, "set#datum#")>
			<cftry>
				<cfinvoke component="#this#" method="set#datum#">
					<cfinvokeargument 
						name="#datum#" 
						value="#arguments.data[datum]#" />
				</cfinvoke>
				<cfcatch type="any">
					<!--- Old --->
					<cfset ArrayAppend(arguments.Errors,
						"There was a problem setting the #datum#!") />
					<!--- New --->
					<cfset arguments.objResult.addError(
						"There was a problem setting the #datum#!") />
				</cfcatch>
			</cftry>
		</cfif>
	</cfloop>
	
</cffunction>

<cffunction name="validate" access="public" returntype="void">
	<!--- Old --->
	<cfargument name="Errors" type="any" required="yes" />
	<!--- New --->
	<cfargument name="objResult" type="any" required="yes" />
	
	<!--- Product must have a name --->
	<cfif Len(getProductName()) EQ 0>
		<!--- Old --->
		<cfset ArrayAppend(arguments.Errors,
			"The Product Name must not be blank!") />
		<!--- New --->
		<cfset arguments.objResult.addError(
			"The Product Name must not be blank!") />
	</cfif>

</cffunction>

</cfcomponent>
