<cfcomponent displayname="ReviewService">

<cffunction name="init" access="Public" returntype="any">
	<cfargument name="ReviewGateway" type="any" required="yes" />
	<cfset variables.ReviewGateway = arguments.ReviewGateway />
	<cfreturn this />
</cffunction>


<cffunction name="getReview" access="Public" returntype="any">
	<cfargument name="ReviewId" type="any" required="yes" />
	<cfreturn variables.ReviewGateway.getReview(arguments.ReviewId) />
</cffunction>


<cffunction name="updateReview" access="public" returntype="any">
	<cfargument name="ReviewId" type="any" required="yes" />
	<cfargument name="data" type="any" required="yes" />
	
	<cfset var objResult = 
		CreateObject("component","model.util.Result").init() />

	<!--- Get a Review object to work with --->
	<cfset objReview = getReview(arguments.ReviewId) />

	<!--- Populate the Review with data provided by the user --->
	<cfset objReview.populate(arguments.data,objResult) />

	<!--- Make sure the Review is still valid --->
	<cfset objReview.validate(objResult) />

	<cfif objResult.getIsSuccess()>
		<!--- OK to save the Review --->
		<cfset variables.ReviewGateway.saveReview(objReview) />
	</cfif>
	
	<cfreturn objResult />
</cffunction>

</cfcomponent>
