<cfcomponent displayname="AbstractService">

<cffunction name="init" access="Public" returntype="any">
	<cfargument name="theGateway" type="any" required="yes" />
	<cfset variables.theGateway = arguments.theGateway />
	<cfreturn this />
</cffunction>


<cffunction name="get" access="Public" returntype="any">
	<cfargument name="theId" type="any" required="yes" />
	<cfreturn variables.theGateway.get(arguments.theId) />
</cffunction>


<cffunction name="update" access="public" returntype="any">
	<cfargument name="theId" type="any" required="yes" />
	<cfargument name="data" type="any" required="yes" />
	
	<cfset var objResult = 
		CreateObject("component","model.util.Result").init() />

	<!--- Get an object to work with --->
	<cfset theObject = get(arguments.theId) />

	<!--- Populate the object with data provided by the user --->
	<cfset theObject.populate(arguments.data,objResult) />
	
	<!--- Make sure the object is still valid --->
	<cfset theObject.validate(objResult) />

	<cfif objResult.getIsSuccess()>
		<!--- OK to save the object --->
		<cfset variables.theGateway.save(theObject) />
	</cfif>
	
	<cfreturn objResult />
</cffunction>

</cfcomponent>
